<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XWirelessLanProfileGroup StructType
 * @subpackage Structs
 */
class XWirelessLanProfileGroup extends AbstractStructBase
{
    /**
     * The wirelessProfile
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $wirelessProfile;
    /**
     * The index
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $index;
    /**
     * Constructor method for XWirelessLanProfileGroup
     * @uses XWirelessLanProfileGroup::setWirelessProfile()
     * @uses XWirelessLanProfileGroup::setIndex()
     * @param XFkType $wirelessProfile
     * @param string $index
     */
    public function __construct(XFkType $wirelessProfile = null, $index = null)
    {
        $this
            ->setWirelessProfile($wirelessProfile)
            ->setIndex($index);
    }
    /**
     * Get wirelessProfile value
     * @return XFkType|null
     */
    public function getWirelessProfile()
    {
        return $this->wirelessProfile;
    }
    /**
     * Set wirelessProfile value
     * @param XFkType $wirelessProfile
     * @return XWirelessLanProfileGroup
     */
    public function setWirelessProfile(XFkType $wirelessProfile = null)
    {
        $this->wirelessProfile = $wirelessProfile;
        return $this;
    }
    /**
     * Get index value
     * @return string|null
     */
    public function getIndex()
    {
        return $this->index;
    }
    /**
     * Set index value
     * @uses XInteger::valueIsValid()
     * @uses XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $index
     * @return XWirelessLanProfileGroup
     */
    public function setIndex($index = null)
    {
        // validation for constraint: enumeration
        if (!XInteger::valueIsValid($index)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $index, implode(', ', XInteger::getValidValues())), __LINE__);
        }
        $this->index = $index;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return XWirelessLanProfileGroup
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
